/**
  Sample SourceCode For NE-USB

  @Company
	Patlite Corporation

  @File Name
	main.c

  @Summary
	This is a sample source code to control NE-USB.

  @Description
	It describes how to control the NE-USB connected with USB cable as a HID device.

*/
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <unistd.h>
#include "hidapi_linux/hidapi.h"	// for linux
// #include "hidapi_mac/hidapi.h"		// for macOS

int main()
{
	int seq = 0;
	int result = 0; // HIDAPI function call result

	// Initialize the HIDAPI library
	result = patlite_init();

	// Open the device 
	result = patlite_device_open();
	if(result != 0) {
		return 0;
	}

	for (int i = 0; i < 3; i++) {
		if(result < 0) break;
		for (seq = 0; seq < 7; seq++) {
			printf("seq = %d\n", seq);
			switch (seq) {
				case 0:
					result = patlite_lights(LED_COLOR_RED, LED_PATTERN_CONTINUOUS);
					break;
				case 1:
					result = patlite_lights(LED_COLOR_GREEN, LED_PATTERN_CONTINUOUS);
					break;
				case 2:
					result = patlite_lights(LED_COLOR_YELLOW, LED_PATTERN_CONTINUOUS);
					break;
				case 3:
					result = patlite_lights(LED_COLOR_BLUE, LED_PATTERN_CONTINUOUS);
					break;
				case 4:
					result = patlite_lights(LED_COLOR_PURPLE, LED_PATTERN_CONTINUOUS);
					break;
				case 5:
					result = patlite_lights(LED_COLOR_CYAN, LED_PATTERN_CONTINUOUS);
					break;
				case 6:
					result = patlite_lights(LED_COLOR_WHITE, LED_PATTERN_CONTINUOUS);
					break;
				default:
					result = patlite_lights(LED_COLOR_OFF, LED_PATTERN_CONTINUOUS);
					break;
			}

			if(result < 0) break;
			sleep(3);
		}

		if(result < 0) break;
		for (seq = 0; seq < 8; seq++) {
			printf("seq = %d\n", seq);
			switch (seq) {
				case 0:
					result = patlite_buzzer(BUZZER_PATTERN_CONTINUOUS);
					break;
				case 1:
					result = patlite_buzzer(BUZZER_PATTERN_NO1);
					break;
				case 2:
					result = patlite_buzzer(BUZZER_PATTERN_NO2);
					break;
				case 3:
					result = patlite_buzzer(BUZZER_PATTERN_NO3);
					break;
				case 4:
					result = patlite_buzzer(BUZZER_PATTERN_NO4);
					break;
				case 5:
					result = patlite_buzzer(BUZZER_PATTERN_NO5);
					break;
				case 6:
					result = patlite_buzzer(BUZZER_PATTERN_NO6);
					break;
				default:
					result = patlite_buzzer(BUZZER_PATTERN_OFF);
					break;
			}
			
			if(result < 0) break;
			sleep(3);
		}
	}

	patlite_device_close();
	return 0;
}
